#include "marinas-gui.ch"

Function main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

   REQUEST HB_LANG_ESWIN 
   REQUEST HB_CODEPAGE_ESWIN
   HB_CDPSELECT('ESWIN')
   HB_LANGSELECT('ESWIN')
   
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )
*----------------------------------------------------*
  SET DELETE ON
  SET DECIMALS TO 3
  SET FIXED ON
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO "dd/mm/yyyy"
  SET ESCAPE ON
  SET ENTERTAB .T.   // <---- SET NAVIGATION EXTENDED 
*-----------------------------------------------------*

   PRIVATE Filtro  

   OpenTables()

   CREATE WINDOW Form_1 
      ROW 0
      COL 0
      WIDTH  568       
      HEIGHT 595    
      CAPTION ""   
      MAIN .T.
      NOMAXIMIZEBUTTON .T.        
      ICON "Resource/home.png"  
      BACKCOLOR { 219 , 244 , 208 }    

      CREATE KEY ESCAPE
         ACTION mg_Do( "Form_1" , "release" )
      END KEY 

*----------------------------   Rutina TIMER cedida por Lucho Miranda   ---------------------------------*
      CREATE TIMER Clock
             INTERVAL 1000                              
             ACTION   ( Form_1.Title :="Base Empleados"+ SPACE(02)+" Fecha: " + DTOC(DATE()) + ;
                        SPACE(05) + "Hora: "   + TIME() )
             ENABLED .T.
      END TIMER
*---------------------------------------------------------------------------------------------------------* 
   Use test index test Via 'DBFCDX' 
             
   CREATE BROWSE Browse_1
      ROW 023                           
      COL 022                                   
      WIDTH   522                          
      HEIGHT  172                          
      BACKCOLOR { 255,223,255 }      
      FONTCOLOR { 057,134,101 } 
      SELECTIONBACKCOLOR { 255,000,000 }
      FONTITALIC .F.                 
      FONTBOLD .T.
      FONTSIZE 10
      WORKAREA "Test" 
      COLUMNFIELDALL  { 'Test->Code','Test->First','Test->Last','Test->Married','Test->Birth'} 
      COLUMNHEADERALL { 'Code','First Name','Last Name','Married','Birth Date' } 
      COLUMNWIDTHALL  { 46,152,152,55,90 }
      COLUMNALIGNALL  { Qt_AlignRight , Qt_AlignLeft , Qt_AlignLeft ,Qt_AlignLeft , Qt_AlignHCenter }
      NAVIGATEBY "ROW"
      TOOLTIP "Browse Test->Base"
      ONNAVIGATECELL { || myBrowseOnNavigateCell() }
      ONDBLCLICK { || BrowseEdit() }
      VALUE 1
   END BROWSE

*---------------------------------------------------------------------------------------------------------* 

 CREATE LABEL LabelCode ;ROW 220 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "Code:";FONTNAME "ARIAL";FONTSIZE 9;  FONTBOLD .T. ;END LABEL    
            
 CREATE TEXTBOX TextBoxCode ;ROW 220; COL 119; WIDTH 100;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                  ALIGN Qt_AlignRight ;VALUE ""  ;   END TEXTBOX
   
 CREATE LABEL LabelFirst ;ROW 250 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "First Name:" ;FONTNAME "ARIAL";FONTSIZE 9; FONTBOLD .T. ; END LABEL

 CREATE TEXTBOX TextBoxFirst ;ROW 250; COL 119; WIDTH 300;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                  VALUE ""  ;   END TEXTBOX
   
 CREATE LABEL LabelLast ;ROW 280 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "Last Name:" ;FONTNAME "ARIAL";FONTSIZE 9; FONTBOLD .T. ; END LABEL

 CREATE TEXTBOX TextBoxLast ;ROW 280; COL 119; WIDTH 300;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                  VALUE ""  ;   END TEXTBOX
   
 CREATE LABEL LabelBirthdate ;ROW 310 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "Birth Date:" ;FONTNAME "ARIAL";FONTSIZE 9; FONTBOLD .T. ; END LABEL

 CREATE TEXTBOX DatePickerBirth ;ROW 310; COL 119; WIDTH 100;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                  VALUE Date()  ;   END TEXTBOX
 
 CREATE LABEL LabelMarried ;ROW 340 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "Married:" ;FONTNAME "ARIAL";FONTSIZE 9;  FONTBOLD .T. ;END LABEL

 CREATE CHECKBOX CheckBoxMarried  ;ROW 340; COL 119; WIDTH 100;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ; FONTBOLD .T. 
                  VALUE .T.  ; CAPTION "Yes Married"   
                  ONCHANGE mg_Get( "Form_1" , "CheckBoxMarried" , "value" ) ; END  CHECKBOX
 
 CREATE LABEL LabelBio ;ROW 370 ;COL 034;WIDTH 95 ;HEIGHT 25;VALUE "Bio:" ;FONTNAME "ARIAL";FONTSIZE 9; FONTBOLD .T. ; END LABEL

 CREATE EDITBOX EditBoxBio ;ROW 370; COL 119; WIDTH 300;HEIGHT 128;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                               VALUE ""  ; END EDITBOX
   
 CREATE IMAGE ImagePhoto ;ROW 341;COL 445 ;WIDTH 100;HEIGHT 125; PICTURE "Photo\00000.Bmp";END IMAGE

 CREATE TEXTBOX TextBoxPhoto ;ROW 475; COL 445; WIDTH 100;HEIGHT 25;FONTNAME "ARIAL";FONTSIZE 9 ;BACKCOLOR {223,242,253} 
                ALIGN Qt_AlignRight;  VALUE ""  ;INPUTMASK "99999"; MAXLENGTH 5;  END TEXTBOX
 
*---------------------------------------------------------------------------------------------------------* 

     CREATE BUTTON ButtonNew
          ROW    210
          COL    445
          WIDTH  100
          HEIGHT 28
          CAPTION "&New" 
          ONCLICK ButtonNewClick() 
          PICTURE "resource/New.Bmp"
          FONTNAME "Arial"
          FONTSIZE  9  
          FONTBOLD .T.
          FONTITALIC .T.
          TOOLTIP ""    
     END BUTTON

     CREATE BUTTON ButtonSave
          ROW    240
          COL    445
          WIDTH  100
          HEIGHT 28
          CAPTION "&Save"
          ONCLICK ButtonSaveClick()
          PICTURE "resource/Grabar.Bmp" 
          FONTNAME "Arial"
          FONTSIZE  9  
          FONTBOLD .T.
          FONTITALIC .T.
          TOOLTIP ""    
     END BUTTON
    
     CREATE BUTTON ButtonCancel
          ROW    270
          COL    445
          WIDTH  100
          HEIGHT 28
          CAPTION "&Cancel"
          ONCLICK ButtonCancelClick()
          PICTURE "resource/Cancel.Bmp"
          FONTNAME "Arial"
          FONTSIZE  9  
          FONTBOLD .T.
          FONTITALIC .T.
          TOOLTIP ""    
     END BUTTON

     CREATE BUTTON ButtonDelete
          ROW    300
          COL    445
          WIDTH  100
          HEIGHT 28
          CAPTION "&Delete"
          ONCLICK ButtonDeleteClick()
          PICTURE "resource/Erase.Bmp"
          FONTNAME "Arial"
          FONTSIZE  9  
          FONTBOLD .T.
          FONTITALIC .T.
          TOOLTIP ""    
     END BUTTON
 *---------------------------------------------------*   
     CREATE BUTTON ButtonExit
          ROW    522
          COL    445
          WIDTH  100
          HEIGHT 52
          CAPTION "&Exit" 
          TOOLTIP "Button Exit Tooltip"
          ONCLICK FinalProgram()                 
          PICTURE "resource/Exit.Bmp"
          FONTNAME "Arial"
          FONTSIZE  9  
          FONTBOLD .T.
          FONTITALIC .T.
     END BUTTON
 *---------------------------------------------------*   
     CREATE FRAMEBOX FrameBox_4
         ROW    517
         COL    245
         WIDTH  191
         HEIGHT 060
         CAPTION "Botones"
     END FRAMEBOX            

     CREATE BUTTON But_01  
         ROW 538
         COL 250           
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\01.Bmp'  
         TOOLTIP 'Primero'    
         ONCLICK  DbGoTop()                            
     END BUTTON

     CREATE BUTTON But_02 
         ROW 538
         COL 280
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\02.Bmp'  
         TOOLTIP 'Anterior - 12'    
         ONCLICK DbSkip(-12)                   
     END BUTTON

     CREATE BUTTON But_03 
         ROW 538
         COL 310
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\03.Bmp'  
         TOOLTIP 'Anterior'   
         ONCLICK DbSkip(-1)                    
     END BUTTON
 
     CREATE BUTTON But_04
         ROW 538
         COL 340
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\04.Bmp'  
         TOOLTIP 'Siguiente'    
         ONCLICK  DbSkip(1)             
     END BUTTON    
               
     CREATE BUTTON But_05
         ROW 538
         COL 370
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\05.Bmp'  
         TOOLTIP 'Siguiente + 12'
         ONCLICK  DbSkip(12)              
     END BUTTON                    

     CREATE BUTTON But_06
         ROW 538
         COL 400
         WIDTH 30
         HEIGHT 30 
         PICTURE 'Resource\06.Bmp'  
         TOOLTIP 'Ultimo' 
         ONCLICK DbGoBottom()                         
     END BUTTON     
 
 *-----------------------------------------------------------------*
 *-----------------------------------------------------------------*

     CREATE FRAMEBOX FrameBox_44
          ROW    517
          COL    010                        
          WIDTH  228
          HEIGHT 060
          CAPTION "Buscar Datos"    
     END FRAMEBOX

     CREATE LABEL Label_44
          ROW    534
          COL    019                     
          WIDTH  120
          HEIGHT 24
          VALUE "Buscar:"
          FONTNAME "Arial"
          FONTSIZE 9
          FONTBOLD .T.
          FONTITALIC .T.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          VISIBLE .T.
          TRANSPARENT .F.
          AUTOSIZE .F.
     END LABEL   

     CREATE TEXTBOX Text_44
          ROW    538
          COL    074                      
          WIDTH  150
          HEIGHT 24
          FONTNAME "Arial"
          FONTSIZE 9
          TOOLTIP "Buscar Por Culaquier Letra"
          ONCHANGE { || Filtrar() }         
          ONGOTFOCUS Nil
          ONLOSTFOCUS Nil
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          ONENTER Nil    
          VISIBLE .T.
          READONLY .F.
          BACKCOLOR {183,214,255} 
     END TEXTBOX

    Form_1.Browse_1.Value := 1

 *-----------------------------------------------------------------*
 *-----------------------------------------------------------------*
                
	END WINDOW
	
	Form_1.TextBoxCode.Enabled := .f.
	Form_1.TextBoxFirst.Enabled := .f.
	Form_1.TextBoxLast.Enabled := .f.
	Form_1.DatePickerBirth.Enabled := .f.
	Form_1.CheckBoxMarried.Enabled := .f.
	Form_1.TextBoxPhoto.Enabled := .f.	
	Form_1.EditBoxBio.Enabled := .f.
	Form_1.ButtonSave.Enabled := .f.
	Form_1.ButtonCancel.Enabled := .f.

        Form_1.Browse_1.SetFocus
        
	CENTER WINDOW Form_1        
	ACTIVATE WINDOW Form_1

 Return Nil
 *------------------------------------------------------------------*

*----------------------------------*
 Function OpenTables()
*----------------------------------*
   use test new
   index on Code    tag "code01" to "test"
   index on First   tag "name01" to "test"
   OrdSetFocus( "code01" )
   
   DBGoTop()
   Return .T.

*----------------------------------*
 Function CloseTables()
*----------------------------------*
	Close all
 Return Nil

*----------------------------------*
 Function FinalProgram() 
*----------------------------------*
       IF mg_MsgYesNo("Desea Salir al Sistema??","Salir al Sistema","Salir") = .T.
          CloseTables() 
          mg_Do( "Form_1" , "Release" )
          Return .T.
       EndIf
  Return NIL

*----------------------------------*
 FUNCTION Filtrar()
*----------------------------------*
 
    SELECT 1   
                  
    IF len(Form_1.Text_44.Value) != 0
       Filtro := Form_1.Text_44.Value     //  <--- UPPER(Form_1.Text_44.Value) o LOWER  Mayusculas o Minusculas 
       SET FILTER TO AT(Filtro,test->first) <>0
       myBrowseOnNavigateCell()   
       SET FILTER TO Filtro $ first         
       Form_1.Browse_1.Refresh
     ELSE
       SET FILTER TO
       Form_1.Browse_1.Refresh
    ENDIF
 
  RETURN NIL 

*----------------------------------*
  Function myBrowseOnNavigateCell()
*----------------------------------*
      
*----------------- >  Memo y Picture

     mg_Set( "Form_1" , "EditBoxBio"  , "value", alltrim( mg_allstr( TEST-> BIO ) ) )
     mg_Set( "Form_1" , "ImagePhoto"  , "picture" , TEST->PHOTO  )
     mg_Set( "Form_1" , "TextBoxPhoto", "value", TEST->PHOTO)

*----------------- >  Memo y Picture

*----------------- >  TextBox

      mg_Set( "Form_1" , "TextBoxCode"     , "value" , STR( TEST->CODE ) )
      mg_Set( "Form_1" , "TextBoxFirst"    , "value" , alltrim( TEST->FIRST ) )
      mg_Set( "Form_1" , "TextBoxLast"     , "value" , alltrim( TEST->LAST ) )
      mg_Set( "Form_1" , "DatePickerBirth" , "value" , DTOC( TEST->BIRTH ) )    
      mg_Set( "Form_1" , "CheckBoxMarried" , "value" , TEST->MARRIED )
    
 Return .T.
*--------------------------------------------------------------*

*----------------------------------*
 Function BrowseEdit()
*----------------------------------*

	Form_1.TextBoxCode.Enabled  := .t.     
	Form_1.TextBoxFirst.Enabled := .t.
	Form_1.TextBoxLast.Enabled  := .t.
	Form_1.DatePickerBirth.Enabled := .t.
	Form_1.CheckBoxMarried.Enabled := .t.
	Form_1.TextBoxPhoto.Enabled := .t.
	Form_1.EditBoxBio.Enabled   := .t.
	Form_1.ButtonNew.Enabled    := .f.
	Form_1.ButtonSave.Enabled   := .t.
	Form_1.ButtonCancel.Enabled := .t.
	Form_1.ButtonDelete.Enabled := .f.
	
	Form_1.TextBoxFirst.SetFocus

Return Nil

*----------------------------------*
 Function ButtonNewClick()
*----------------------------------*

	Form_1.TextBoxCode.Value     := "" 
	Form_1.TextBoxFirst.Value    := "" 
	Form_1.TextBoxLast.Value     := "" 
	Form_1.DatePickerBirth.Value := date() 
        Form_1.TextBoxPhoto.Value    := "00000" 

	Form_1.CheckBoxMarried.Value := .t. 
	Form_1.EditBoxBio.Value      :=  "" 
	
	Form_1.ImagePhoto.Picture := "Photo\00000.bmp"

	Form_1.TextBoxFirst.Enabled  := .t.
	Form_1.TextBoxLast.Enabled   := .t.
	Form_1.DatePickerBirth.Enabled := .t.
	Form_1.CheckBoxMarried.Enabled := .t.	
	Form_1.TextBoxPhoto.Enabled  := .t.
	Form_1.EditBoxBio.Enabled    := .t.
	Form_1.ButtonNew.Enabled     := .f.
	Form_1.ButtonSave.Enabled    := .t.
	Form_1.ButtonCancel.Enabled  := .t.
	Form_1.ButtonDelete.Enabled  := .f.	
	Form_1.Browse_1.Enabled      := .f.

	Form_1.TextBoxFirst.SetFocus

 Return Nil

*----------------------------------*
 Function ButtonDeleteClick()
*----------------------------------*
       
       IF mg_MsgYesNo("Desea Borrar Registo ?"+Chr(13)+Chr(10) +;             // + HB_OsNewLine() + ;         
                      "Code:  "+alltrim(str(Test->Code))+Chr(13)+Chr(10)+;   //  + HB_OsNewLine() + ;
		      "First Name: "+alltrim(Test->First) ," ","Borrar Registros")

              SELECT 1
              REPLACE First WITH " "
          
              mg_Msginfo("Registro Borrado","Borrar Registros")

              SELECT 1
              DELETE FOR First =" "
              PACK 
              OrdSetFocus( "code01" )   
              dbGoTop()             
              Form_1.Browse_1.Value := 1
              Form_1.Browse_1.Refresh
              Form_1.Browse_1.SetFocus
              RETURN NIL 
             ELSE         
              RETURN NIL 
       ENDIF             

 RETURN NIL

*----------------------------------*
 Function ButtonSaveClick()
*----------------------------------*

	Local vTextBoxCode     := Val( Form_1.TextBoxCode.Value ) 
	Local vTextBoxFirst    := Form_1.TextBoxFirst.Value 
	Local vTextBoxLast     := Form_1.TextBoxLast.Value 
	Local vDatePickerBirth := CTOD(Form_1.DatePickerBirth.Value) 
	Local vCheckBoxMarried := Form_1.CheckBoxMarried.Value 
	Local vEditBoxBio      := Form_1.EditBoxBio.Value 
	
	If vTextBoxCode <= 0
		Goto Bottom
		vTextBoxCode := Test->Code + 1
		Append Blank
		Replace Test->Code With vTextBoxCode
	End
	
	Replace Test->First   With vTextBoxFirst
	Replace Test->Last    With vTextBoxLast
	Replace Test->Birth   With vDatePickerBirth
	Replace Test->Married With vCheckBoxMarried

        IF mg_Get("Form_1","TextBoxPhoto","value") <= " "
              Replace Test->Photo WITH "Photo\" + "00000" + ".png"
            ELSE  
              Replace Test->Photo WITH "Photo\" + mg_Get("Form_1","TextBoxPhoto","value") + ".bmp"
        ENDIF

        Replace Test->Bio     With vEditBoxBio
	Commit

	Form_1.TextBoxCode.Enabled := .f.
	Form_1.TextBoxFirst.Enabled := .f.
	Form_1.TextBoxLast.Enabled := .f.
	Form_1.DatePickerBirth.Enabled := .f.
	Form_1.CheckBoxMarried.Enabled := .f.
	Form_1.TextBoxPhoto.Enabled := .f.
	Form_1.EditBoxBio.Enabled := .f.
	Form_1.ButtonNew.Enabled := .t.
	Form_1.ButtonSave.Enabled := .f.
	Form_1.ButtonCancel.Enabled := .f.	
	Form_1.ButtonDelete.Enabled := .t.
	Form_1.Browse_1.Enabled := .t.
	
	Form_1.ImagePhoto.Picture := alltrim(Test->Photo)

 
        SELECT 1
 
        DELETE FOR First =" "
        PACK 
           
        OrdSetFocus( "code01" ) 

	Form_1.Browse_1.Value := 1
	Form_1.Browse_1.Refresh
	Form_1.Browse_1.SetFocus

  Return NIL

*----------------------------------*
 Function ButtonCancelClick()
*----------------------------------*

        Form_1.TextBoxCode.Enabled  := .F.     
	Form_1.TextBoxFirst.Enabled := .f.
	Form_1.TextBoxLast.Enabled := .f.
	Form_1.DatePickerBirth.Enabled := .f.
	Form_1.CheckBoxMarried.Enabled := .f.
	Form_1.TextBoxPhoto.Enabled := .f.
	Form_1.EditBoxBio.Enabled := .f.
	Form_1.ButtonNew.Enabled := .t.
	Form_1.ButtonSave.Enabled := .f.
	Form_1.ButtonCancel.Enabled := .f.
	Form_1.ButtonDelete.Enabled := .t.
	Form_1.Browse_1.Enabled := .t.

	Form_1.TextBoxCode.Value := "" 	
	Form_1.TextBoxFirst.Value :=  "" 
	Form_1.TextBoxLast.Value :=  "" 
	Form_1.CheckBoxMarried.Value :=  .t. 
	Form_1.TextBoxPhoto.Value :=  ""
	Form_1.EditBoxBio.Value :=  "" 
	
	Form_1.ImagePhoto.Picture := "Photo\00000.bmp"

        Form_1.Browse_1.Value := 1	
	Form_1.Browse_1.SetFocus

 Return NIL




